#include <unistd.h> 
#include <stdio.h>
#include <netdb.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <stdlib.h>
#include <errno.h>
#include <string.h>
#include <signal.h>
#include <pthread.h>
#include "strutture.h"
#include "parametri.h"

int sock;

void int_handler(int sig){
	printf("\nchiudo la socket...");
	close(sock);
	printf("\n...e muoio\n\n");
	exit(1);
}

void stampa_help_comandi(){
	printf("\n\t----Lista Comandi----\n\nLOGIN <username>\nSELEZIONA <numero_sala>\nLIST\nPRENOTA <posto_1> ... <posto_n>\nQUIT\n\n");
}
struct comando *leggi_comando(){
	struct comando *comando = malloc(sizeof(struct comando));
	//printf("\n--------------------------------------------\n");
	printf("\n> ");
	char input[MAX_LENGTH_INPUT];		
	char** output = malloc(MAX_NUMERO_PARAMETRI*sizeof(char*));//sicuro???????????????????????????
	char c='A';
	int i = 0;
	while(c!='\n'){
		scanf("%s",(char*)&input);
		output[i] = malloc(strlen(input)*sizeof(char));
		strcpy(output[i],input);
		i++;
		scanf("%c",&c);		
	}	
	comando->num_parametri = i;
	comando->parametri = output;	
	return comando;
}
void invia_comando(struct comando *comando){
	int i = 0;
	int n = comando->num_parametri;	
	if( write(sock, comando->parametri[i], strlen(comando->parametri[i]) ) <= 0 ) {
			printf("errore %s durante la write\n", strerror(errno));
			exit(1);
		}
	i++;
	while(i<n){//invio il comando
		if( write(sock,&SEPARATORE_PARAMETRO,sizeof(SEPARATORE_PARAMETRO)) <= 0 ) {
			printf("errore %s durante la write\n", strerror(errno));
			exit(1);
		}
		if( write(sock, comando->parametri[i], strlen(comando->parametri[i]) ) <= 0 ) {
			printf("errore %s durante la write\n", strerror(errno));
			exit(1);
		}		
		i++;
	}	
	if( write(sock, &FINE_PACCHETTO, sizeof(FINE_PACCHETTO) ) <= 0 ) {//simbolo di fine pacchetto
			printf("errore %s durante la write\n", strerror(errno));
			exit(1);
	}
	if( write(sock, &FINE_PACCHETTO2, sizeof(FINE_PACCHETTO2) ) <= 0 ) {//simbolo di fine pacchetto
			printf("errore %s durante la write\n", strerror(errno));
			exit(1);
	}
	//printf("\nfine pacchetto da inviare\n");
	//leggo la risposta
	char input[256];
	char** output = malloc(256*sizeof(char));			
	char c;
	i = 0;		
	int len = read(sock ,&c ,sizeof(c));
	if ( len == 0 ) {printf("\nconnection closed by the server\n");kill(getpid(),SIGINT);}
	if ( len < 0 ) {printf("\nerrore\n");kill(getpid(),SIGINT);}	
	while (c!=FINE_PACCHETTO2){
		int k = 0;
		while (c!=SEPARATORE_PARAMETRO && c!=FINE_PACCHETTO){
			input[k] = c;
			len = read(sock ,&c ,sizeof(c));
			if ( len == 0 ) {printf("\nconnection closed by the server\n");kill(getpid(),SIGINT);}
			if ( len < 0 ) {printf("\nerrore\n");kill(getpid(),SIGINT);}	
			k++;
		}			
		input[k] = '\0';
		printf("%s ",input);
		output[i] = malloc(strlen(input)*sizeof(char));
		output[i] = input;
		i++;
		len = read(sock, &c, sizeof(c));		
		if ( len == 0 ) {printf("\nconnection closed by the server\n");kill(getpid(),SIGINT);}
		if ( len < 0 ) {printf("\nerrore\n");kill(getpid(),SIGINT);}	
	}
}

int main(int argc,char **argv){
	signal(SIGINT,int_handler);
	struct sockaddr_in server;
	struct hostent *hp;	
	if(argc!=3) {
		printf("uso: %s <host> <numero-della-porta>\n",argv[0]);
		exit(1);
    }
	hp = gethostbyname(argv[1]);
	if( hp == NULL ){
		printf("%s: l'host %s e' sconosciuto MAX_CARATTERI_INPUT = 256.\n",argv[0], argv[1]);
		exit(1);
    }
    sock = socket(AF_INET, SOCK_STREAM, 0);
	if( sock < 0 ) {
		printf("errore %s nella creazione del socket\n",strerror(errno));
		exit(1);
	}
	server.sin_family = AF_INET;
	bcopy(hp->h_addr, &server.sin_addr, hp->h_length);
	server.sin_port = htons(atoi(argv[2]));
	if( connect(sock, (struct sockaddr *)&server, sizeof(server)) < 0 ){
		printf("errore %s durante la connect\n",strerror(errno));
		exit(1);
	}
	printf("connesso a %s, porta %d\n", argv[1],ntohs(server.sin_port));	
	while(1){
		struct comando *comando = leggi_comando();	
		if(strcmp(comando->parametri[0],"QUIT")==0 && comando->num_parametri==1) break;		
		invia_comando(comando);
		free_comando(comando);//deallocare tutta la struct????
	}	
	close(sock);
	printf("ho chiuso il socket\n");	
	return 0;
}
