#include <stdio.h>   
#include <stdlib.h>         
#include <sys/socket.h>     
#include <sys/types.h>
#include <netinet/in.h>
#include <netdb.h>
#include <errno.h>  
#include <string.h> 
#include <signal.h> 
#include <unistd.h>  
#include <pthread.h>
#include "strutture.h"
#include "server_utility.h"

int prenota(struct posto** posti_da_prenotare, int indice, char* user_name){// ordinamento gerarchico decrescente dei mutex, evita lo stallo
	printf("%s chiede il mutex su %s\n",user_name,posti_da_prenotare[indice]->coordinate_posto);
	pthread_mutex_lock(&posti_da_prenotare[indice]->mutex);
	printf("%s acquisito il mutex su %s\n",user_name,posti_da_prenotare[indice]->coordinate_posto);
	//sleep(3);
	if (posti_da_prenotare[indice]->stato==1){		
		pthread_mutex_unlock(&posti_da_prenotare[indice]->mutex);
		printf("%s rilascia il mutex su %s perchè è già prenotato\n",user_name,posti_da_prenotare[indice]->coordinate_posto);
		return 0;
	}	
	if (indice!=0 && prenota(posti_da_prenotare,indice-1,user_name) == 0) {		
		pthread_mutex_unlock(&posti_da_prenotare[indice]->mutex);
		printf("%s rilascia il mutex su %s perchè funzione ricorsiva ha ritornato zero\n",user_name,posti_da_prenotare[indice]->coordinate_posto);
		return 0;				
	}
	posti_da_prenotare[indice]->stato = 1;	
	posti_da_prenotare[indice]->proprietario = malloc(strlen(user_name)+1);
	strcpy(posti_da_prenotare[indice]->proprietario,user_name);
	pthread_mutex_unlock(&posti_da_prenotare[indice]->mutex);
	printf("%s rilascia il mutex su %s\n",user_name,posti_da_prenotare[indice]->coordinate_posto);
	return 1;
}
int prenota_posti (int sockmsg,struct comando* comando, struct sala_cinema* sala_corrente, char* user_name){
	struct posto** posti_da_prenotare = malloc(sala_corrente->numero_posti*sizeof(struct posto));//fare la free!
	int numero_posti = get_posti_ordinati(comando,sala_corrente,posti_da_prenotare);			
	if(numero_posti==comando->num_parametri-1){		//comando corretto
		if (prenota(posti_da_prenotare,numero_posti-1,user_name)==0) write2(sockmsg,"COMANDO INCORRETO: posti già prenotati", strlen("COMANDO INCORRETO: posti già prenotati"));
		else write2(sockmsg,"COMANDO ESEGUITO", strlen("COMANDO ESEGUITO"));
	}else{		//comando errato
		write2(sockmsg,"COMANDO INCORRETTO: posti non esistenti", strlen("COMANDO INCORRETTO: posti non esistenti"));
	}			
	free(posti_da_prenotare);
}

int list_sale(int sockmsg, struct cinema* cinema){
	char message[256];
	sprintf(message, "\t----lista delle sale----");
	write2(sockmsg, message, strlen(message));
	int i = 0;
	for(i=0;i<cinema->numero_sale;i++) {
		sprintf(message,"\n\nsala: %i\nfilm: %s\norario: %s",cinema->lista_sale[i]->numero_sala,cinema->lista_sale[i]->nome_film,cinema->lista_sale[i]->orario);
		write2(sockmsg, message, strlen(message));
	}
}

int list_posti(int sockmsg, struct sala_cinema* sala_corrente){
	char message[256];
	sprintf(message, "\t----lista dei posti della sala %i film %s orario %s----",sala_corrente->numero_sala,sala_corrente->nome_film,sala_corrente->orario);
	write2(sockmsg, message, strlen(message));
	int i = 0;
	char last = '\0';
	for(i=0;i<sala_corrente->numero_posti;i++) {
		if (sala_corrente->posti[i]->coordinate_posto[0] != last){
			write2(sockmsg, "\n", 1);
			last = sala_corrente->posti[i]->coordinate_posto[0];
		}
		char stato = 'P';
		if (sala_corrente->posti[i]->stato == 0) stato = 'L';
		sprintf(message,"| %s, %c, %s |",sala_corrente->posti[i]->coordinate_posto,stato,sala_corrente->posti[i]->proprietario);
		write2(sockmsg, message, strlen(message));
	}
}

int stampa_help(int sockmsg,int user_is_logged){
	char message[256];
	if(user_is_logged) strcpy(message,"\t----Lista Comandi----\nLOGIN <username>\nLOGOUT\nLIST\nSELEZIONA <numero_sala>\nINDIETRO\nPRENOTA <posto_1> ... <posto_n>\nQUIT");
	else strcpy(message,"\t----Lista Comandi----\nLOGIN <username>\nQUIT");
	write2(sockmsg, message, strlen(message));
}

