#include <stdio.h>   
#include <stdlib.h>         
#include <sys/socket.h>     
#include <sys/types.h>
#include <netinet/in.h>
#include <netdb.h>
#include <errno.h>  
#include <string.h> 
#include <signal.h> 
#include <unistd.h>  
#include <pthread.h>
#include "strutture.h"
#include "server_utility.h"
#include "parametri.h"

int sock;
struct cinema* cinema;

void int_handler(int sig){
	printf("\nchiudo la socket...");
	//close(sockmsg);
	close(sock);
	printf("...e muoio\n\n");
	exit(1);
}
void *gestore_connessione(void* arg);

int main(int argc, char** argv){
	signal(SIGINT,int_handler);	
	struct sockaddr_in server;
	if ( argc != 2 ) {printf("uso: %s <numero-della-porta>\n",argv[0]);exit(EXIT_FAILURE);}	
	if( (sock = socket(AF_INET, SOCK_STREAM, 0)) < 0 ) {printf("server %d: errore %s nel creare la socket\n",getpid(), strerror(errno));exit(1);}
	server.sin_family = AF_INET;
	server.sin_addr.s_addr = INADDR_ANY;
	server.sin_port = htons(atoi(argv[1]));
	if( bind(sock, (struct sockaddr *)&server, sizeof(server)) ) {printf("bind fallita :%s\n", getpid(),strerror(errno));exit(EXIT_FAILURE);}
	printf("rispondo sulla porta %d\n",getpid(), ntohs(server.sin_port));
	if( listen(sock,CODA_BACKLOG) <0 ) {printf("errore %s nella listen\n",getpid(), strerror(errno));exit(EXIT_FAILURE);}	
	cinema = carica_cinema();     //inizializzo il cinema	
	while(1) {		//ciclo del server
		int* sockmsg = malloc(sizeof(int));
		if( (*sockmsg = accept(sock, 0, 0)) <0 ) {printf("errore %s nella accept\n",getpid(), strerror(errno));exit(1);}
		pthread_t mythread;
		pthread_create(&mythread,NULL,gestore_connessione,sockmsg);
		pthread_detach(mythread);
		
	} /* fine del ciclo infinito del server */
	close(sock); /* inutile: non arrivero’ mai qui! */
	printf("ho chiuso la socket di ascolto\n",getpid());	
	return 0;	
}

void *gestore_connessione(void* arg){
	printf("accettata una nuova connessione\n",getpid());
	int sockmsg = *((int*)arg);
	free(arg);
	int user_is_logged = 0;
	char user_name[MAX_LENGTH_INPUT];
	struct sala_cinema* sala_corrente = NULL;
	
	while(1) {		//questo è il ciclo della connessione, da inserire nel thread
		struct comando *comando = malloc(sizeof(struct comando));
		char input[MAX_LENGTH_INPUT];
		char** output = malloc(MAX_NUMERO_PARAMETRI*sizeof(char*));			
		char c;
		int i;		
		int len;			
		if ( (len = read(sockmsg ,&c ,sizeof(c))) == 0 ) {printf("connection closed by the client\n");close(sockmsg);pthread_exit(NULL);}
		if ( len < 0 ) {printf("errore %s durante la read\n", strerror(errno));close(sockmsg);pthread_exit(NULL);}//thread exit
		for (i=0; c!=FINE_PACCHETTO2; i++){
			int k;
			for (k=0; c!=SEPARATORE_PARAMETRO && c!=FINE_PACCHETTO; k++){
				input[k] = c;
				if ( (len = read(sockmsg ,&c ,sizeof(c))) == 0 ) {printf("connection closed by the client\n");close(sockmsg);pthread_exit(NULL);}
				if ( len < 0 ) {printf("errore %s durante la read\n", strerror(errno));close(sockmsg);pthread_exit(NULL);}	//thread exit
			}			
			input[k] = '\0';
			//printf("ho letto una stringa:-%s-\n",input);				
			output[i] = malloc(strlen(input)*sizeof(char));
			strcpy(output[i],input);
			if ( (len = read(sockmsg ,&c ,sizeof(c))) == 0 ) {printf("connection closed by the client\n");close(sockmsg);pthread_exit(NULL);}
			if ( len < 0 ) {printf("errore %s durante la read\n", strerror(errno));close(sockmsg);pthread_exit(NULL);}	//thread exit			
		}
		//printf("ho finito di leggere il comando\n");
		comando->num_parametri = i;
		comando->parametri = output;	
		//eseguo il comando	
		char message[256];		
		if (strcmp(comando->parametri[0],"LIST")==0 && user_is_logged==1 && comando->num_parametri==1 && sala_corrente==NULL) list_sale(sockmsg,cinema);
		else if (strcmp(comando->parametri[0],"LIST")==0 && user_is_logged==1 && comando->num_parametri==1 && sala_corrente!=NULL) list_posti(sockmsg, sala_corrente);
		else if (strcmp(comando->parametri[0],"SELEZIONA")==0 && user_is_logged==1 && comando->num_parametri==2 && (sala_corrente = cerca_sala(cinema,comando->parametri[1])) != NULL) ;
		else if (strcmp(comando->parametri[0],"INDIETRO")==0 && user_is_logged==1 && comando->num_parametri==1) sala_corrente = NULL;				
		else if (strcmp(comando->parametri[0],"PRENOTA")==0 && user_is_logged==1 && comando->num_parametri>=2 && sala_corrente!=NULL) prenota_posti(sockmsg,comando,sala_corrente,user_name);
		else if(strcmp(comando->parametri[0],"LOGIN")==0 && comando->num_parametri==2){
			sprintf(user_name,"%s", comando->parametri[1]);
			sprintf(message, "Ciao %s, benvenuto al cinema multisala %s",user_name,cinema->nome_cinema);
			write2(sockmsg, message, strlen(message));
			user_is_logged = 1;
			sala_corrente = NULL;
		}else if(strcmp(comando->parametri[0],"LOGOUT")==0 && user_is_logged==1 && comando->num_parametri==1){
			sprintf(message, "Arrivederci %s, il cinema multisala %s la saluta",user_name,cinema->nome_cinema);
			write2(sockmsg, message, strlen(message));
			strcpy(user_name,"");
			user_is_logged = 0;
			sala_corrente = NULL;
		}else if(strcmp(comando->parametri[0],"QUIT")==0 && comando->num_parametri==1){				
			break;
		}else if(strcmp(comando->parametri[0],"HELP")==0 && comando->num_parametri==1) stampa_help(sockmsg,user_is_logged);
		else{
			write2(sockmsg, "COMANDO ERRATO, digita HELP per avere aiuto", strlen("COMANDO ERRATO, digita HELP per avere aiuto"));
		}			
		//chiudo la risposta
		write2(sockmsg,&FINE_PACCHETTO,1);	
		write2(sockmsg,&FINE_PACCHETTO2,1);	
		free_comando(comando);
	}		
				
	printf("ho chiuso la socket di dialogo\n",getpid());
	close(sockmsg);
	pthread_exit(NULL);
}


