#include <stdio.h>   
#include <stdlib.h>         
#include <sys/socket.h>     
#include <sys/types.h>
#include <netinet/in.h>
#include <netdb.h>
#include <errno.h>  
#include <string.h> 
#include <signal.h> 
#include <unistd.h>  
#include <pthread.h>
#include "strutture.h"

int write2(int sockmsg,const void* buf,unsigned int length){
	if (write(sockmsg,buf,length)<0) {
		perror("errore nella write");
		close(sockmsg);
		pthread_exit(NULL);
	}
}

struct sala_cinema *cerca_sala (struct cinema* cinema,char* sala){
	int numero_sala = atoi(sala);
	int i;
	for (i=0; i<cinema->numero_sale; i++){
		if (cinema->lista_sale[i]->numero_sala == numero_sala)
			return cinema->lista_sale[i];
	}
	return NULL;
}

void free_comando(struct comando *comando){
	int i;
	for (i=0; i<comando->num_parametri; i++) free(comando->parametri[i]);
	free(comando);
}

int get_posti_ordinati(struct comando* comando,struct sala_cinema* sala_cinema,struct posto** posti){
	//posti = malloc(sala_cinema->numero_posti*sizeof(struct posto));
	int i, k = 0;
	for (i=0; i<sala_cinema->numero_posti; i++){//si suppone che i posti della sala del cinema siano ordinati
		if (comando_contiene_posto(comando,sala_cinema->posti[i]->coordinate_posto) == 1){
			posti[k] = sala_cinema->posti[i];
			k++;
		}
	}
	return k;
}

int comando_contiene_posto(struct comando* comando,char* coordinate_posto){
	int i;
	for(i=1; i<comando->num_parametri; i++){
		if(strcmp(comando->parametri[i],coordinate_posto)==0)
			return 1;
	}
	return 0;
}

