#include <unistd.h> 
#include <stdio.h>
#include <netdb.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <stdlib.h>
#include <errno.h>
#include <string.h>
#include <signal.h>
#include <pthread.h>
#include "strutture.h"
#include "parametri.h"
#include <math.h>

struct hostent *hp;
struct sockaddr_in server;
int numero_thread = 382;//non superare il numero 382, altrimenti SIGSEV
char nome_posto[256]= "";

int check_comando_eseguito(char* r){
	if(r[0]=='C' & r[1]=='O' & r[2]=='M' & r[3]=='A' & r[4]=='N' & r[5]=='D' & r[6]=='O' & r[7]==' ' & r[8]=='E' & r[9]=='S' & r[10]=='E' & r[11]=='G' & r[12]=='U' & r[13]=='I' & r[14]=='T' & r[15]=='O')	
		return 1;
	return 0;
}

void *thread_function(void *arg){
	int sock = socket(AF_INET, SOCK_STREAM, 0);	
	if( sock < 0 ) {printf("errore %s nella creazione del socket\n",strerror(errno));exit(1);}
	if( connect(sock, (struct sockaddr *)&server, sizeof(server)) < 0 ){printf("errore %s durante la connect\n",strerror(errno));exit(1);}
	int parametro = *(int*)arg;
	char id[256] = "";
	sprintf(id,"%i",parametro);
	free(arg);
		
	/*int r = rand();	
	printf("%i - %i\n",r);
	if ((r%3)==0)
		sleep(2);
	else if ((r%3)==1)
		sleep(1);
		*/
	sleep(1);
	
	char message[256] = "LOGIN thread";
	strcat(message,id);
	strcat(message,"\r\n");
	write(sock,message,strlen(message));
	char c=' ';
	while(c!='\r') read(sock ,&c ,sizeof(c));
	read(sock ,&c ,sizeof(c));
	
	strcpy(message,"SELEZIONA 3\r\n");	
	write(sock,message,strlen(message));	
	while(c!='\r') read(sock ,&c ,sizeof(c));
	read(sock ,&c ,sizeof(c));
	
	strcpy(message,"PRENOTA");
	strcat(message,nome_posto);
	strcat(message,"\r\n");
	write(sock,message,strlen(message));
	char response[100];
	int k = 0;
	while(c!='\r') {
		read(sock ,&c ,sizeof(c));
		response[k] = c;		
		k++;
	}	
	read(sock ,&c ,sizeof(c));	
	if (check_comando_eseguito(response)) printf("SONO thread%s, SONO RIUSCITO A PRENOTARE %s\n\n",id,nome_posto);	
		
	close(sock);
	//printf("ho chiuso il socket, sono %s\n",id);
	
	pthread_exit(NULL);
}

void stampa_sala();

int main(int argc,char **argv){			
	if(argc<5) {printf("uso: %s <host> <numero-della-porta> <numero-thread> <coordinate-posto1> ... <coordinate-poston>\n",argv[0]);exit(1);}
	numero_thread = atoi(argv[3]);
	int i;
	for(i=4;i<argc;i++){
		strcat(nome_posto," ");
		strcat(nome_posto,argv[i]);			
	}
	hp = gethostbyname(argv[1]);
	if( hp == NULL ){printf("%s: l'host %s e' sconosciuto MAX_CARATTERI_INPUT = 256.\n",argv[0], argv[1]);exit(1);}
	server.sin_family = AF_INET;
	bcopy(hp->h_addr, &server.sin_addr, hp->h_length);
	server.sin_port = htons(atoi(argv[2]));	
	pthread_t id_thread[numero_thread];
	int contatore;
	stampa_sala();
	for(contatore=0; contatore<numero_thread; contatore++)	{
		int* parametro = malloc(sizeof(int));
		*parametro = contatore;		
		pthread_create(&id_thread[contatore],NULL,thread_function,parametro);		
	}
	for(contatore=0; contatore<numero_thread; contatore++)	{
		pthread_join(id_thread[contatore],NULL);		
	}	
	stampa_sala();	
	return 0;
}

void stampa_sala(){
	int sock = socket(AF_INET, SOCK_STREAM, 0);	
	if( sock < 0 ) {printf("errore %s nella creazione del socket\n",strerror(errno));exit(1);}
	if( connect(sock, (struct sockaddr *)&server, sizeof(server)) < 0 ){printf("errore %s durante la connect\n",strerror(errno));exit(1);}
	
	char message[256] = "LOGIN controllore\r\n";
	write(sock,message,strlen(message));
	char c=' ';
	while(c!='\r') read(sock ,&c ,sizeof(c));
	read(sock ,&c ,sizeof(c));
	
	strcpy(message,"SELEZIONA 3\r\n");	
	write(sock,message,strlen(message));	
	while(c!='\r') read(sock ,&c ,sizeof(c));		
	read(sock ,&c ,sizeof(c));
	
	
	strcpy(message,"LIST\r\n");	
	write(sock,message,strlen(message));	
	while(c!='\r') {
		read(sock ,&c ,sizeof(c));
		printf("%c",c);
	}		
	read(sock ,&c ,sizeof(c));
	printf("%c\n",c);	
		
	close(sock);
}

